//
//  RPSGameViewController.m
//  RPS2
//
//  Created by Edward Benson on 1/12/10.
//  Copyright 2010 MIT. All rights reserved.
//

#import "RPSGameViewController.h"
#import "NSString+RPS.h"
#import "AboutController.h"

@implementation RPSGameViewController

-(id)init {
	if (self = [super init]) {
		selfThrow = nil;
		otherThrow = nil;
	}
	return self;
}

- (IBAction)rockClicked:(id)sender {
	[self receiveThrow:@"rock"];
}

- (IBAction)paperClicked:(id)sender {
	[self receiveThrow:@"paper"];
}

- (IBAction)scissorsClicked:(id)sender {
	[self receiveThrow:@"scissors"];
}

- (IBAction)aboutClicked:(id)sender {
	AboutController *ac = [[[AboutController alloc] init] autorelease];
	UINavigationController *nav = [[UINavigationController alloc] initWithRootViewController:ac];
	[self presentModalViewController:nav animated:YES];
	[nav release];
}

-(void)receiveThrow:(NSString *)theThrow {
	if (selfThrow == nil) {
		selfThrow = [theThrow copy];
		selfLabel.text = [[theThrow capitalizedString] stringByAppendingString:@"!"];
	}
	else if (otherThrow == nil) {
		otherThrow = [theThrow copy];
		otherLabel.text = [[theThrow capitalizedString] stringByAppendingString:@"!"];
		[self completeGame];
	}
}

-(void)completeGame {
	if ([selfThrow rpsBeats:otherThrow]) {
		outcomeLabel.text = @"Player 1 Wins!";
	}
	else {
		outcomeLabel.text = @"Player 2 Wins!";
	}
}

-(void)resetGame {
	[selfThrow release];
	selfThrow = nil;
	[otherThrow release];
	otherThrow = nil;
	outcomeLabel.text = nil;
	selfLabel.text = nil;
	otherLabel.text = nil;
}

- (IBAction)resetGameClicked:(id)sender {
	[self resetGame];
}


/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
}
*/

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}

- (void)dealloc {
	[selfThrow release];
	[otherThrow release];
    [super dealloc];
}


@end
